/*
	ScrollView.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSView.h"

@class NSScroller;
@class NSClipView;
@class NSColor;

@interface NSScrollView : NSView
{
    id                  vScroller;
    id                  hScroller;
    id                  contentView;
    float               pageContext;
    float               lineAmount;
    struct __sFlags {
#ifdef __BIG_ENDIAN__
	unsigned int        vScrollerRequired:1;
	unsigned int        hScrollerRequired:1;
	unsigned int        vScrollerStatus:1;
	unsigned int        hScrollerStatus:1;
	unsigned int        noDynamicScrolling:1;
	unsigned int        borderType:2;
	unsigned int        rulerInstalled:1;
	unsigned int        _RESERVED:8;
#else
	unsigned int        _RESERVED:8;
	unsigned int        rulerInstalled:1;
	unsigned int        borderType:2;
	unsigned int        noDynamicScrolling:1;
	unsigned int        hScrollerStatus:1;
	unsigned int        vScrollerStatus:1;
	unsigned int        hScrollerRequired:1;
	unsigned int        vScrollerRequired:1;
#endif
    }                   _sFlags;
    id                  _ruler;
}

+ (NSSize)frameSizeForContentSize:(NSSize)cSize hasHorizontalScroller:(BOOL)hFlag hasVerticalScroller:(BOOL)vFlag borderType:(NSBorderType)aType;
+ (NSSize)contentSizeForFrameSize:(NSSize)fSize hasHorizontalScroller:(BOOL)hFlag hasVerticalScroller:(BOOL)vFlag borderType:(NSBorderType)aType;

- (NSRect)documentVisibleRect;
- (NSSize)contentSize;
- resizeSubviewsWithOldSize:(NSSize)oldSize;
- drawRect:(NSRect)rect;
- setDocView:aView;
- docView;
- setDocCursor:anObj;
- (NSBorderType)borderType;
- setBorderType:(NSBorderType)aType;
- setBackgroundColor:(NSColor *)color;
- (NSColor *)backgroundColor;
- setVertScrollerRequired:(BOOL)flag;
- setHorizScrollerRequired:(BOOL)flag;
- vertScroller;
- horizScroller;
- setVertScroller:anObject;
- setHorizScroller:anObject;
- setLineScroll:(float)value;
- setPageScroll:(float)value;
- setCopyOnScroll:(BOOL)flag;
- setDisplayOnScroll:(BOOL)flag;
- setDynamicScrolling:(BOOL)flag;
- tile;
- reflectScroll:cView;

@end

@interface NSScrollView(Ruler)
- toggleRuler:sender;
- ruler;
@end

